Bug 462535 - Review Request: python-foolscap - Next-generation RPC protocol, intended to replace Perspective Broker
Review Request: python-foolscap - Next-generation RPC protocol, intended to r...
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: David Carter
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2008-09-16 18:28 EDT by Ruben Kerkhof
Modified: 2011-02-17 09:20 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2009-04-29 10:40:38 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
dcarter: fedora‑review+
tibbs: fedora‑cvs+

Attachments (Terms of Use)
koji build log showing test case errors (76.96 KB, text/x-log)
2009-02-24 22:48 EST, David Carter
no flags Details

  None (edit)
Description Ruben Kerkhof 2008-09-16 18:28:10 EDT
Spec URL: http://ruben.fedorapeople.org/python-foolscap.spec
SRPM URL: http://ruben.fedorapeople.org/python-foolscap-0.3.1-1.fc10.src.rpm
Foolscap (aka newpb) is a new version of Twisted's native RPC protocol, known
as 'Perspective Broker'. This allows an object in one process to be used by
code in a distant process. This module provides data marshaling, a remote
object reference system, and a capability-based security model.
Comment 1 David Carter 2008-10-30 18:46:27 EDT
This is a sample review only, as I'm not currently sponsored.

$ rpmlint -i python-foolscap-0.3.1-1.fc10.src.rpm 
python-foolscap.src: W: mixed-use-of-spaces-and-tabs (spaces: line 5, tab: line 18)
The specfile mixes use of spaces and tabs for indentation, which is a cosmetic
annoyance.  Use either spaces or tabs for indentation, not both.

1 packages and 0 specfiles checked; 0 errors, 1 warnings.

$ rpmlint -i python-foolscap-0.3.1-1.fc10.noarch.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

I don't think the mixed format should prohibit a release, but it should be fixed before any subsequent releases.

Package meets name guidelines, as does the .spec file.

Spec file Changelog is OK.

License is OK, build fine on both i386 and x86_64.

Nice and simple :)
Comment 2 Ruben Kerkhof 2008-10-31 11:16:54 EDT
Thanks David!

New version here:
Spec URL: http://ruben.fedorapeople.org/python-foolscap.spec
SRPM URL: http://ruben.fedorapeople.org/python-foolscap-0.3.1-2.fc10.src.rpm
Comment 3 Gwyn Ciesla 2008-10-31 12:21:57 EDT

BuildRequires:   python

See: https://fedoraproject.org/wiki/Packaging/Python

Files is python_sitelib are not in a module subdirectory, and should be.

David, I'd also like to see a more detailed review.  Early in learning the review process, many find it helpful to use a template.  What I do is paste a copy of the ReviewGuidelines into the bug, and go through it section by section, annotating each with either OK or FIX, and summarizing at the end.  This helps prevent omissions, and I speak from experience here. :)

Other than that and the above, I concur with your review.
Comment 4 Ruben Kerkhof 2008-11-01 20:25:08 EDT
Thanks Jon,

New version here:
Spec URL: http://ruben.fedorapeople.org/python-foolscap.spec
SRPM URL: http://ruben.fedorapeople.org/python-foolscap-0.3.1-3.fc9.src.rpm
Comment 5 Jason Tibbitts 2008-12-06 22:25:36 EST
This unfortunately does not build for me:

+ /usr/bin/python setup.py install -O1 --skip-build --root /builddir/build/BUILDROOT/python-foolscap-0.3.1-3.fc11.x86_64
running install
error: invalid Python installation: unable to open /usr/lib64/python2.6/config/Makefile (No such file or directory)

In the off chance that was an issue with the new python 2.6 in rawhide, I built it for F10 and had the same problem.
Comment 6 Ruben Kerkhof 2008-12-07 17:41:36 EST
Hmm, not sure what's wrong there. That Makefile is included in python-devel, which is a BR. It builds fine in mock on rawhide for me. I've been trying to do a scratchbuild but Koji seems to be having an issue.
Comment 7 Ruben Kerkhof 2009-02-23 17:32:53 EST
Ok, I just did a scratchbuild of the latest foolscap (0.3.2), and all seems fine now.

Here's the scratchbuild:

New version here:
Spec URL: http://ruben.fedorapeople.org/python-foolscap.spec
SRPM URL: http://ruben.fedorapeople.org/python-foolscap-0.3.2-1.fc11.src.rpm
Comment 8 David Carter 2009-02-24 22:47:19 EST
Again, this is a practice review, so treat accordingly.

It seemed to go fine except when building with koji where it failed some test cases. This didn't occur when building locally, or with mock. There may be some lock issues. I'm attaching the build log from koji.

MUST: rpmlint must be run on every package.
rpmlint -i /var/lib/mock/fedora-10-x86_64/result/python-foolscap-0.3.2-1.fc10.*
2 packages and 0 specfiles checked; 0 errors, 0 warnings.

MUST: The package must be named according to the Package Naming Guidelines

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.

MUST: The package must meet the Packaging Guidelines

MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines

MUST: The License field in the package spec file must match the actual license.

MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc

MUST: The spec file must be written in American English.

MUST: The spec file for the package MUST be legible.

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.

MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
OK fc10-x86_64

MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.

MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.

MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.

MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.

MUST: A package must not contain any duplicate files in the %files listing.

MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.

MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).

MUST: Each package must consistently use macros.

MUST: The package must contain code, or permissable content.

MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).

MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.

MUST: Header files must be in a -devel package.

MUST: Static libraries must be in a -static package.

MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).

MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.

MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}

MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.

MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.

MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.

MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).

MUST: All filenames in rpm packages must be valid UTF-8.

SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.

SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.

SHOULD: The reviewer should test that the package builds in mock.

SHOULD: The package should compile and build into binary rpms on all supported architectures.
Failed some of the test cases in koji. Error log attached. Ran fine in mock.

SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example

SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.

SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.

SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.

SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
Comment 9 David Carter 2009-02-24 22:48:04 EST
Created attachment 333130 [details]
koji build log showing test case errors
Comment 10 David Carter 2009-02-24 22:50:21 EST
That's "clock issues" not "lock issues" :)
Comment 11 Ruben Kerkhof 2009-02-25 04:18:36 EST
Ah, the answer is in the logs:

Warning: tests will fail (unclean reactor warnings)
when pyOpenSSL >= 0.7 is used in conjunction with
Twisted <= 8.1.0 . The workaround is to use the pollreactor
instead of the default selectreactor (trial -r poll).
This bug is fixed in Twisted trunk, and should appear
in the next release of Twisted.
 pyOpenSSL version: 0.7
 Twisted version: 2.5.0
 reactor: <twisted.internet.selectreactor.SelectReactor object at 0xf790c2b0>
See http://foolscap.lothar.com/trac/ticket/62 for details.

That might explain why the tests fail for you on Fedora 10, and work on rawhide (it has a newer version of Twisted). I'm only planning to build python-foolscap for rawhide though, so we should be fine.
Comment 12 David Carter 2009-02-25 06:43:59 EST
Yes, it build fine under koji with dist-f11. I'm unable to build it under mock at this time as it has some unrelated yum issues. So I guess as a practice reviewer, I'm OK with it as it is.

Now you just need someone authorized to approve :)
Comment 13 David Carter 2009-04-28 10:01:39 EDT
Re-review is the same, builds ok and clean under Koji. So now that I can, I approve.
Comment 14 Ruben Kerkhof 2009-04-28 16:28:57 EDT
Thanks for the review David, and welcome to the Fedora Packagers.

New Package CVS Request
Package Name: python-foolscap
Short Description: Next-generation RPC protocol
Owners: ruben
Branches: F-11
Comment 15 Kevin Fenzi 2009-04-28 22:50:34 EDT
cvs done.
Comment 16 David Cantrell 2011-02-11 20:40:36 EST
Package Change Request
Package Name: python-foolscap
New Branches: el6
Owners: dcantrel
Comment 17 Jason Tibbitts 2011-02-15 14:18:21 EST
Need an ack from the Fedora maintainer here.
Comment 18 Ruben Kerkhof 2011-02-15 14:42:29 EST
Comment 19 Jason Tibbitts 2011-02-17 09:20:06 EST
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.